//--------------------------------------------------------------------------
// Visual Database Tools
// Copyright (c) 1995, 1995 by Borland International, All Rights Reserved
//
//   Additional definitions for database access COM interfaces.
//--------------------------------------------------------------------------

#ifndef BDTM_H
#define BDTM_H

//
// Mangle the function, class and variable names so we can have
// mulitpale versions of the same functions and variables in one
// .LIB file.
//
#if defined( __DLL__ ) && ! defined( __FLAT__ )
#  if defined( _RTLDLL ) // user DLL linked with RTL.DLL
#    define IID_IDispatch         dIID_IDispatch
#    define IID_IEnumVARIANT      dIID_IEnumVARIANT
#    define IID_ITypeInfo         dIID_ITypeInfo
#    define IID_ITypeLib          dIID_ITypeLib
#    define IID_ITypeComp         dIID_ITypeComp
#    define IID_ICreateTypeInfo   dIID_ICreateTypeInfo
#    define IID_ICreateTypeLib    dIID_ICreateTypeLib
#    define IID_StdOle            dIID_StdOle
#    define IID_IErrorInfo        dIID_IErrorInfo
#    define IID_ICreateErrorInfo  dIID_ICreateErrorInfo
#    define IID_ISupportErrorInfo dIID_ISupportErrorInfo
#    define LIBID_BDT50           dLIBID_BDT50
#    define IID_IBDT50            dIID_IBDT50
#    define DIID_DBDT50           dDIID_DBDT50
#    define CLSID_BDT50           dCLSID_BDT50
#    define IID_ITBDTObject       dIID_ITBDTObject
#    define DIID_DTBDTObject      dDIID_DTBDTObject
#    define IID_ITBDTComponent    dIID_ITBDTComponent
#    define DIID_DTBDTComponent   dDIID_DTBDTComponent
#    define IID_ITDataSource      dIID_ITDataSource
#    define DIID_DTDataSource     dDIID_DTDataSource
#    define CLSID_TDataSource     dCLSID_TDataSource
#    define IID_ITDataSet         dIID_ITDataSet
#    define DIID_DTDataSet        dDIID_DTDataSet
#    define IID_ITDBDataSet       dIID_ITDBDataSet
#    define DIID_DTDBDataSet      dDIID_DTDBDataSet
#    define IID_ITTable           dIID_ITTable
#    define DIID_DTTable          dDIID_DTTable
#    define CLSID_TTable          dCLSID_TTable
#    define IID_ITQuery           dIID_ITQuery
#    define DIID_DTQuery          dDIID_DTQuery
#    define CLSID_TQuery          dCLSID_TQuery
#    define IID_ITStoredProc      dIID_ITStoredProc
#    define DIID_DTStoredProc     dDIID_DTStoredProc
#    define CLSID_TStoredProc     dCLSID_TStoredProc
#    define IID_ITDatabase        dIID_ITDatabase
#    define DIID_DTDatabase       dDIID_DTDatabase
#    define CLSID_TDatabase       dCLSID_TDatabase
#    define IID_ITBatchMove       dIID_ITBatchMove
#    define DIID_DTBatchMove      dDIID_DTBatchMove
#    define CLSID_TBatchMove      dCLSID_TBatchMove
#    define IID_ITSession         dIID_ITSession
#    define DIID_DTSession        dDIID_DTSession
#    define CLSID_TSession        dCLSID_TSession
#    define IID_ITField           dIID_ITField
#    define DIID_DTField          dDIID_DTField
#    define CLSID_TField          dCLSID_TField
#    define IID_ITFieldDef        dIID_ITFieldDef
#    define DIID_DTFieldDef       dDIID_DTFieldDef
#    define CLSID_TFieldDef       dCLSID_TFieldDef
#    define IID_ITFieldDefs       dIID_ITFieldDefs
#    define DIID_DTFieldDefs      dDIID_DTFieldDefs
#    define CLSID_TFieldDefs      dCLSID_TFieldDefs
#    define IID_ITIndexDef        dIID_ITIndexDef
#    define DIID_DTIndexDef       dDIID_DTIndexDef
#    define CLSID_TIndexDef       dCLSID_TIndexDef
#    define IID_ITIndexDefs       dIID_ITIndexDefs
#    define DIID_DTIndexDefs      dDIID_DTIndexDefs
#    define CLSID_TIndexDefs      dCLSID_TIndexDefs
#    define IID_ITParam           dIID_ITParam
#    define DIID_DTParam          dDIID_DTParam
#    define CLSID_TParam          dCLSID_TParam
#    define IID_ITParams          dIID_ITParams
#    define DIID_DTParams         dDIID_DTParams
#    define CLSID_TParams         dCLSID_TParams
#    define IID_ITStrings         dIID_ITStrings
#    define DIID_DTStrings        dDIID_DTStrings
#    define CLSID_TStrings        dCLSID_TStrings
#    define IID_ITMemoryStream    dIID_ITMemoryStream
#    define DIID_DTMemoryStream   dDIID_DTMemoryStream
#    define CLSID_TMemoryStream   dCLSID_TMemoryStream
#    define IID_ITAnyString       dIID_ITAnyString
#    define DIID_DTAnyString      dDIID_DTAnyString
#    define CLSID_TAnyString      dCLSID_TAnyString
#    define CLSID_TStringField    dCLSID_TStringField
#    define CLSID_TSmallintField  dCLSID_TSmallintField
#    define CLSID_TIntegerField   dCLSID_TIntegerField
#    define CLSID_TWordField      dCLSID_TWordField
#    define CLSID_TBooleanField   dCLSID_TBooleanField
#    define CLSID_TNumericField   dCLSID_TNumericField
#    define CLSID_TFloatField     dCLSID_TFloatField
#    define CLSID_TCurrencyField  dCLSID_TCurrencyField
#    define CLSID_TBCDField       dCLSID_TBCDField
#    define CLSID_TDateField      dCLSID_TDateField
#    define CLSID_TTimeField      dCLSID_TTimeField
#    define CLSID_TDateTimeField  dCLSID_TDateTimeField
#    define CLSID_TBytesField     dCLSID_TBytesField
#    define CLSID_TVarBytesField  dCLSID_TVarBytesField
#    define CLSID_TBlobField      dCLSID_TBlobField
#    define CLSID_TMemoField      dCLSID_TMemoField
#    define CLSID_TGraphicField   dCLSID_TGraphicField
#    define BDT50                 dBDT50
#    define TBDTObject            dTBDTObject
#    define TBDTComponent         dTBDTComponent
#    define TStrings              dTStrings
#    define TSession              dTSession
#    define TDatabase             dTDatabase
#    define TFieldDef             dTFieldDef
#    define TFieldDefs            dTFieldDefs
#    define TDataSet              dTDataSet
#    define TDBDataSet            dTDBDataSet
#    define TDataSource           dTDataSource
#    define TIndexDef             dTIndexDef
#    define TIndexDefs            dTIndexDefs
#    define TTable                dTTable
#    define TBatchMove            dTBatchMove
#    define TParam                dTParam
#    define TParams               dTParams
#    define TStoredProc           dTStoredProc
#    define TQuery                dTQuery
#    define TMemoryStream         dTMemoryStream
#    define TField                dTField
#    define TStringField          dTStringField
#    define TNumericField         dTNumericField
#    define TIntegerField         dTIntegerField
#    define TSmallintField        dTSmallintField
#    define TWordField            dTWordField
#    define TFloatField           dTFloatField
#    define TCurrencyField        dTCurrencyField
#    define TBCDField             dTBCDField
#    define TBooleanField         dTBooleanField
#    define TDateTimeField        dTDateTimeField
#    define TDateField            dTDateField
#    define TTimeField            dTTimeField
#    define TBytesField           dTBytesField
#    define TVarBytesField        dTVarBytesField
#    define TBlobField            dTBlobField
#    define TMemoField            dTMemoField
#    define TGraphicField         dTGraphicField
#    define TVarRec               dTVarRec
#    define TVarRecs              dTVarRecs
#  else _RTLDLL  // user DLL linked with static libraries
#    define IID_IDispatch         uIID_IDispatch
#    define IID_IEnumVARIANT      uIID_IEnumVARIANT
#    define IID_ITypeInfo         uIID_ITypeInfo
#    define IID_ITypeLib          uIID_ITypeLib
#    define IID_ITypeComp         uIID_ITypeComp
#    define IID_ICreateTypeInfo   uIID_ICreateTypeInfo
#    define IID_ICreateTypeLib    uIID_ICreateTypeLib
#    define IID_StdOle            uIID_StdOle
#    define IID_IErrorInfo        uIID_IErrorInfo
#    define IID_ICreateErrorInfo  uIID_ICreateErrorInfo
#    define IID_ISupportErrorInfo uIID_ISupportErrorInfo
#    define LIBID_BDT50           uLIBID_BDT50
#    define IID_IBDT50            uIID_IBDT50
#    define DIID_DBDT50           uDIID_DBDT50
#    define CLSID_BDT50           uCLSID_BDT50
#    define IID_ITBDTObject       uIID_ITBDTObject
#    define DIID_DTBDTObject      uDIID_DTBDTObject
#    define IID_ITBDTComponent    uIID_ITBDTComponent
#    define DIID_DTBDTComponent   uDIID_DTBDTComponent
#    define IID_ITDataSource      uIID_ITDataSource
#    define DIID_DTDataSource     uDIID_DTDataSource
#    define CLSID_TDataSource     uCLSID_TDataSource
#    define IID_ITDataSet         uIID_ITDataSet
#    define DIID_DTDataSet        uDIID_DTDataSet
#    define IID_ITDBDataSet       uIID_ITDBDataSet
#    define DIID_DTDBDataSet      uDIID_DTDBDataSet
#    define IID_ITTable           uIID_ITTable
#    define DIID_DTTable          uDIID_DTTable
#    define CLSID_TTable          uCLSID_TTable
#    define IID_ITQuery           uIID_ITQuery
#    define DIID_DTQuery          uDIID_DTQuery
#    define CLSID_TQuery          uCLSID_TQuery
#    define IID_ITStoredProc      uIID_ITStoredProc
#    define DIID_DTStoredProc     uDIID_DTStoredProc
#    define CLSID_TStoredProc     uCLSID_TStoredProc
#    define IID_ITDatabase        uIID_ITDatabase
#    define DIID_DTDatabase       uDIID_DTDatabase
#    define CLSID_TDatabase       uCLSID_TDatabase
#    define IID_ITBatchMove       uIID_ITBatchMove
#    define DIID_DTBatchMove      uDIID_DTBatchMove
#    define CLSID_TBatchMove      uCLSID_TBatchMove
#    define IID_ITSession         uIID_ITSession
#    define DIID_DTSession        uDIID_DTSession
#    define CLSID_TSession        uCLSID_TSession
#    define IID_ITField           uIID_ITField
#    define DIID_DTField          uDIID_DTField
#    define CLSID_TField          uCLSID_TField
#    define IID_ITFieldDef        uIID_ITFieldDef
#    define DIID_DTFieldDef       uDIID_DTFieldDef
#    define CLSID_TFieldDef       uCLSID_TFieldDef
#    define IID_ITFieldDefs       uIID_ITFieldDefs
#    define DIID_DTFieldDefs      uDIID_DTFieldDefs
#    define CLSID_TFieldDefs      uCLSID_TFieldDefs
#    define IID_ITIndexDef        uIID_ITIndexDef
#    define DIID_DTIndexDef       uDIID_DTIndexDef
#    define CLSID_TIndexDef       uCLSID_TIndexDef
#    define IID_ITIndexDefs       uIID_ITIndexDefs
#    define DIID_DTIndexDefs      uDIID_DTIndexDefs
#    define CLSID_TIndexDefs      uCLSID_TIndexDefs
#    define IID_ITParam           uIID_ITParam
#    define DIID_DTParam          uDIID_DTParam
#    define CLSID_TParam          uCLSID_TParam
#    define IID_ITParams          uIID_ITParams
#    define DIID_DTParams         uDIID_DTParams
#    define CLSID_TParams         uCLSID_TParams
#    define IID_ITStrings         uIID_ITStrings
#    define DIID_DTStrings        uDIID_DTStrings
#    define CLSID_TStrings        uCLSID_TStrings
#    define IID_ITMemoryStream    uIID_ITMemoryStream
#    define DIID_DTMemoryStream   uDIID_DTMemoryStream
#    define CLSID_TMemoryStream   uCLSID_TMemoryStream
#    define IID_ITAnyString       uIID_ITAnyString
#    define DIID_DTAnyString      uDIID_DTAnyString
#    define CLSID_TAnyString      uCLSID_TAnyString
#    define CLSID_TStringField    uCLSID_TStringField
#    define CLSID_TSmallintField  uCLSID_TSmallintField
#    define CLSID_TIntegerField   uCLSID_TIntegerField
#    define CLSID_TWordField      uCLSID_TWordField
#    define CLSID_TBooleanField   uCLSID_TBooleanField
#    define CLSID_TNumericField   uCLSID_TNumericField
#    define CLSID_TFloatField     uCLSID_TFloatField
#    define CLSID_TCurrencyField  uCLSID_TCurrencyField
#    define CLSID_TBCDField       uCLSID_TBCDField
#    define CLSID_TDateField      uCLSID_TDateField
#    define CLSID_TTimeField      uCLSID_TTimeField
#    define CLSID_TDateTimeField  uCLSID_TDateTimeField
#    define CLSID_TBytesField     uCLSID_TBytesField
#    define CLSID_TVarBytesField  uCLSID_TVarBytesField
#    define CLSID_TBlobField      uCLSID_TBlobField
#    define CLSID_TMemoField      uCLSID_TMemoField
#    define CLSID_TGraphicField   uCLSID_TGraphicField
#    define BDT50                 uBDT50
#    define TBDTObject            uTBDTObject
#    define TBDTComponent         uTBDTComponent
#    define TStrings              uTStrings
#    define TSession              uTSession
#    define TDatabase             uTDatabase
#    define TFieldDef             uTFieldDef
#    define TFieldDefs            uTFieldDefs
#    define TDataSet              uTDataSet
#    define TDBDataSet            uTDBDataSet
#    define TDataSource           uTDataSource
#    define TIndexDef             uTIndexDef
#    define TIndexDefs            uTIndexDefs
#    define TTable                uTTable
#    define TBatchMove            uTBatchMove
#    define TParam                uTParam
#    define TParams               uTParams
#    define TStoredProc           uTStoredProc
#    define TQuery                uTQuery
#    define TMemoryStream         uTMemoryStream
#    define TField                uTField
#    define TStringField          uTStringField
#    define TNumericField         uTNumericField
#    define TIntegerField         uTIntegerField
#    define TSmallintField        uTSmallintField
#    define TWordField            uTWordField
#    define TFloatField           uTFloatField
#    define TCurrencyField        uTCurrencyField
#    define TBCDField             uTBCDField
#    define TBooleanField         uTBooleanField
#    define TDateTimeField        uTDateTimeField
#    define TDateField            uTDateField
#    define TTimeField            uTTimeField
#    define TBytesField           uTBytesField
#    define TVarBytesField        uTVarBytesField
#    define TBlobField            uTBlobField
#    define TMemoField            uTMemoField
#    define TGraphicField         uTGraphicField
#    define TVarRec               uTVarRec
#    define TVarRecs              uTVarRecs
#  endif _RTLDLL
#elif defined( _RTLDLL ) // user EXE linked with RTL.DLL
#  define IID_IDispatch         iIID_IDispatch
#  define IID_IEnumVARIANT      iIID_IEnumVARIANT
#  define IID_ITypeInfo         iIID_ITypeInfo
#  define IID_ITypeLib          iIID_ITypeLib
#  define IID_ITypeComp         iIID_ITypeComp
#  define IID_ICreateTypeInfo   iIID_ICreateTypeInfo
#  define IID_ICreateTypeLib    iIID_ICreateTypeLib
#  define IID_StdOle            iIID_StdOle
#  define IID_IErrorInfo        iIID_IErrorInfo
#  define IID_ICreateErrorInfo  iIID_ICreateErrorInfo
#  define IID_ISupportErrorInfo iIID_ISupportErrorInfo
#  define LIBID_BDT50           iLIBID_BDT50
#  define IID_IBDT50            iIID_IBDT50
#  define DIID_DBDT50           iDIID_DBDT50
#  define CLSID_BDT50           iCLSID_BDT50
#  define IID_ITBDTObject       iIID_ITBDTObject
#  define DIID_DTBDTObject      iDIID_DTBDTObject
#  define IID_ITBDTComponent    iIID_ITBDTComponent
#  define DIID_DTBDTComponent   iDIID_DTBDTComponent
#  define IID_ITDataSource      iIID_ITDataSource
#  define DIID_DTDataSource     iDIID_DTDataSource
#  define CLSID_TDataSource     iCLSID_TDataSource
#  define IID_ITDataSet         iIID_ITDataSet
#  define DIID_DTDataSet        iDIID_DTDataSet
#  define IID_ITDBDataSet       iIID_ITDBDataSet
#  define DIID_DTDBDataSet      iDIID_DTDBDataSet
#  define IID_ITTable           iIID_ITTable
#  define DIID_DTTable          iDIID_DTTable
#  define CLSID_TTable          iCLSID_TTable
#  define IID_ITQuery           iIID_ITQuery
#  define DIID_DTQuery          iDIID_DTQuery
#  define CLSID_TQuery          iCLSID_TQuery
#  define IID_ITStoredProc      iIID_ITStoredProc
#  define DIID_DTStoredProc     iDIID_DTStoredProc
#  define CLSID_TStoredProc     iCLSID_TStoredProc
#  define IID_ITDatabase        iIID_ITDatabase
#  define DIID_DTDatabase       iDIID_DTDatabase
#  define CLSID_TDatabase       iCLSID_TDatabase
#  define IID_ITBatchMove       iIID_ITBatchMove
#  define DIID_DTBatchMove      iDIID_DTBatchMove
#  define CLSID_TBatchMove      iCLSID_TBatchMove
#  define IID_ITSession         iIID_ITSession
#  define DIID_DTSession        iDIID_DTSession
#  define CLSID_TSession        iCLSID_TSession
#  define IID_ITField           iIID_ITField
#  define DIID_DTField          iDIID_DTField
#  define CLSID_TField          iCLSID_TField
#  define IID_ITFieldDef        iIID_ITFieldDef
#  define DIID_DTFieldDef       iDIID_DTFieldDef
#  define CLSID_TFieldDef       iCLSID_TFieldDef
#  define IID_ITFieldDefs       iIID_ITFieldDefs
#  define DIID_DTFieldDefs      iDIID_DTFieldDefs
#  define CLSID_TFieldDefs      iCLSID_TFieldDefs
#  define IID_ITIndexDef        iIID_ITIndexDef
#  define DIID_DTIndexDef       iDIID_DTIndexDef
#  define CLSID_TIndexDef       iCLSID_TIndexDef
#  define IID_ITIndexDefs       iIID_ITIndexDefs
#  define DIID_DTIndexDefs      iDIID_DTIndexDefs
#  define CLSID_TIndexDefs      iCLSID_TIndexDefs
#  define IID_ITParam           iIID_ITParam
#  define DIID_DTParam          iDIID_DTParam
#  define CLSID_TParam          iCLSID_TParam
#  define IID_ITParams          iIID_ITParams
#  define DIID_DTParams         iDIID_DTParams
#  define CLSID_TParams         iCLSID_TParams
#  define IID_ITStrings         iIID_ITStrings
#  define DIID_DTStrings        iDIID_DTStrings
#  define CLSID_TStrings        iCLSID_TStrings
#  define IID_ITMemoryStream    iIID_ITMemoryStream
#  define DIID_DTMemoryStream   iDIID_DTMemoryStream
#  define CLSID_TMemoryStream   iCLSID_TMemoryStream
#  define IID_ITAnyString       iIID_ITAnyString
#  define DIID_DTAnyString      iDIID_DTAnyString
#  define CLSID_TAnyString      iCLSID_TAnyString
#  define CLSID_TStringField    iCLSID_TStringField
#  define CLSID_TSmallintField  iCLSID_TSmallintField
#  define CLSID_TIntegerField   iCLSID_TIntegerField
#  define CLSID_TWordField      iCLSID_TWordField
#  define CLSID_TBooleanField   iCLSID_TBooleanField
#  define CLSID_TNumericField   iCLSID_TNumericField
#  define CLSID_TFloatField     iCLSID_TFloatField
#  define CLSID_TCurrencyField  iCLSID_TCurrencyField
#  define CLSID_TBCDField       iCLSID_TBCDField
#  define CLSID_TDateField      iCLSID_TDateField
#  define CLSID_TTimeField      iCLSID_TTimeField
#  define CLSID_TDateTimeField  iCLSID_TDateTimeField
#  define CLSID_TBytesField     iCLSID_TBytesField
#  define CLSID_TVarBytesField  iCLSID_TVarBytesField
#  define CLSID_TBlobField      iCLSID_TBlobField
#  define CLSID_TMemoField      iCLSID_TMemoField
#  define CLSID_TGraphicField   iCLSID_TGraphicField
#  define BDT50                 iBDT50
#  define TBDTObject            iTBDTObject
#  define TBDTComponent         iTBDTComponent
#  define TStrings              iTStrings
#  define TSession              iTSession
#  define TDatabase             iTDatabase
#  define TFieldDef             iTFieldDef
#  define TFieldDefs            iTFieldDefs
#  define TDataSet              iTDataSet
#  define TDBDataSet            iTDBDataSet
#  define TDataSource           iTDataSource
#  define TIndexDef             iTIndexDef
#  define TIndexDefs            iTIndexDefs
#  define TTable                iTTable
#  define TBatchMove            iTBatchMove
#  define TParam                iTParam
#  define TParams               iTParams
#  define TStoredProc           iTStoredProc
#  define TQuery                iTQuery
#  define TMemoryStream         iTMemoryStream
#  define TField                iTField
#  define TStringField          iTStringField
#  define TNumericField         iTNumericField
#  define TIntegerField         iTIntegerField
#  define TSmallintField        iTSmallintField
#  define TWordField            iTWordField
#  define TFloatField           iTFloatField
#  define TCurrencyField        iTCurrencyField
#  define TBCDField             iTBCDField
#  define TBooleanField         iTBooleanField
#  define TDateTimeField        iTDateTimeField
#  define TDateField            iTDateField
#  define TTimeField            iTTimeField
#  define TBytesField           iTBytesField
#  define TVarBytesField        iTVarBytesField
#  define TBlobField            iTBlobField
#  define TMemoField            iTMemoField
#  define TGraphicField         iTGraphicField
#  define TVarRec               iTVarRec
#  define TVarRecs              iTVarRecs
#endif __DLL__

#endif BDTM_H
